public class Punto implements Comparable {

	int x; int y;
   	
   	public Punto (int x, int y) {
   		this.x = x;
   		this.y = y;
   	}
   	
   	int leggiX() { return x; }
   	int leggiY() { return y; }
   	
   	int distanza() {
      	return (int) Math.sqrt(x * x + y * y);
    }
   	
  //overriding
   	public String toString() {
   		return "("+ x + "," + y + ")";
   	}

   	//overriding
   	public boolean equals(Object obj) {
   		if (obj == null) return false;
   		if (!(obj instanceof Punto)) return false;
   		Punto p = (Punto) obj;
   		return ((x == p.x) && (y == p.y));
   	}
   	   	
   	
   	public int compareTo(Object obj) {
   		//ordinamento naturale: distanza dallorigine
   		if (this.distanza() < ((Punto)obj).distanza()) return -1;
   		else if (distanza() > ((Punto)obj).distanza()) return 1;
   			 else return 0;
   	}
   	/*  
   	public boolean maggioreDi (Punto o) {
   // criterio dordinamento la distanza dallorigine
         return distanza() >= o.distanza();
   }
   	 */
   	
}//end-class
